Index: issm/trunk/src/c/classes/Constraints/SpcStatic.cpp
===================================================================
--- issm/trunk/src/c/classes/Constraints/SpcStatic.cpp	(revision 18081)
+++ issm/trunk/src/c/classes/Constraints/SpcStatic.cpp	(revision 18301)
@@ -14,11 +14,9 @@
 
 /*SpcStatic constructors and destructor*/
-/*FUNCTION SpcStatic::SpcStatic(){{{*/
-SpcStatic::SpcStatic(){
+SpcStatic::SpcStatic(){/*{{{*/
 	return;
 }
 /*}}}*/
-/*FUNCTION SpcStatic::SpcStatic(int spc_sid,int spc_nodeid,...){{{*/
-SpcStatic::SpcStatic(int spc_sid,int spc_nodeid, int spc_dof,IssmDouble spc_value,int spc_analysis_type){
+SpcStatic::SpcStatic(int spc_sid,int spc_nodeid, int spc_dof,IssmDouble spc_value,int spc_analysis_type){/*{{{*/
 
 	sid           = spc_sid;
@@ -31,6 +29,5 @@
 }
 /*}}}*/
-/*FUNCTION SpcStatic::~SpcStatic{{{*/
-SpcStatic::~SpcStatic(){
+SpcStatic::~SpcStatic(){/*{{{*/
 	return;
 }
@@ -38,6 +35,5 @@
 
 /*Object virtual functions definitions:*/
-/*FUNCTION SpcStatic::Echo {{{*/
-void SpcStatic::Echo(void){
+void SpcStatic::Echo(void){/*{{{*/
 
 	_printf_("SpcStatic:\n");
@@ -50,6 +46,5 @@
 }
 /*}}}*/
-/*FUNCTION SpcStatic::DeepEcho {{{*/
-void SpcStatic::DeepEcho(void){
+void SpcStatic::DeepEcho(void){/*{{{*/
 
 	_printf_("SpcStatic:\n");
@@ -62,9 +57,7 @@
 }		
 /*}}}*/
-/*FUNCTION SpcStatic::Id {{{*/
-int    SpcStatic::Id(void){ return sid; }
+int SpcStatic::Id(void){ return sid; }/*{{{*/
 /*}}}*/
-/*FUNCTION SpcStatic::ObjectEnum{{{*/
-int SpcStatic::ObjectEnum(void){
+int SpcStatic::ObjectEnum(void){/*{{{*/
 
 	return SpcStaticEnum;
@@ -72,19 +65,25 @@
 }
 /*}}}*/
-/*FUNCTION SpcStatic::copy {{{*/
-Object* SpcStatic::copy() {
-	return new SpcStatic(*this); 
+Object* SpcStatic::copy() {/*{{{*/
+	
+	SpcStatic* spcstat = new SpcStatic(*this); 
+
+	spcstat->sid=this->sid;
+	spcstat->nodeid=this->nodeid;
+	spcstat->dof=this->dof;
+	spcstat->value=this->value;
+	spcstat->analysis_type=this->analysis_type;
+
+	return (Object*) spcstat;
 }
 /*}}}*/
 
 /*Constraint virtual functions definitions: */
-/*FUNCTION SpcStatic::InAnalysis{{{*/
-bool SpcStatic::InAnalysis(int in_analysis_type){
+bool SpcStatic::InAnalysis(int in_analysis_type){/*{{{*/
 	if (in_analysis_type==this->analysis_type) return true;
 	else return false;
 }
 /*}}}*/
-/*FUNCTION SpcStatic::ConstrainNode{{{*/
-void SpcStatic::ConstrainNode(Nodes* nodes,Parameters* parameters){
+void SpcStatic::ConstrainNode(Nodes* nodes,Parameters* parameters){/*{{{*/
 
 	Node* node=NULL;
@@ -101,17 +100,14 @@
 
 /*SpcStatic functions*/
-/*FUNCTION SpcStatic::GetDof {{{*/
-int SpcStatic::GetDof(){
+int SpcStatic::GetDof(){/*{{{*/
 	return dof;
 }
 /*}}}*/
-/*FUNCTION SpcStatic::GetNodeId {{{*/
-int   SpcStatic::GetNodeId(){
+int   SpcStatic::GetNodeId(){/*{{{*/
 
 	return nodeid;
 }
 /*}}}*/
-/*FUNCTION SpcStatic::GetValue {{{*/
-IssmDouble SpcStatic::GetValue(){
+IssmDouble SpcStatic::GetValue(){/*{{{*/
 	_assert_(!xIsNan<IssmDouble>(value));
 	return value;
Index: issm/trunk/src/c/classes/Constraints/SpcTransient.cpp
===================================================================
--- issm/trunk/src/c/classes/Constraints/SpcTransient.cpp	(revision 18081)
+++ issm/trunk/src/c/classes/Constraints/SpcTransient.cpp	(revision 18301)
@@ -14,6 +14,5 @@
 
 /*SpcTransient constructors and destructor*/
-/*FUNCTION SpcTransient::SpcTransient(){{{*/
-SpcTransient::SpcTransient(){
+SpcTransient::SpcTransient(){/*{{{*/
 	sid=-1;
 	nodeid=-1;
@@ -26,6 +25,5 @@
 }
 /*}}}*/
-/*FUNCTION SpcTransient::SpcTransient(int spc_sid,int spc_nodeid,...){{{*/
-SpcTransient::SpcTransient(int spc_sid,int spc_nodeid, int spc_dof,int spc_nsteps, IssmDouble* spc_times, IssmDouble* spc_values,int spc_analysis_type){
+SpcTransient::SpcTransient(int spc_sid,int spc_nodeid, int spc_dof,int spc_nsteps, IssmDouble* spc_times, IssmDouble* spc_values,int spc_analysis_type){/*{{{*/
 
 	sid=spc_sid;
@@ -43,6 +41,5 @@
 }
 /*}}}*/
-/*FUNCTION SpcTransient::~SpcTransient{{{*/
-SpcTransient::~SpcTransient(){
+SpcTransient::~SpcTransient(){/*{{{*/
 	xDelete<IssmDouble>(times);
 	xDelete<IssmDouble>(values);
@@ -52,6 +49,5 @@
 
 /*Object virtual functions definitions:*/
-/*FUNCTION SpcTransient::Echo {{{*/
-void SpcTransient::Echo(void){
+void SpcTransient::Echo(void){/*{{{*/
 
 	int i;
@@ -69,14 +65,11 @@
 }
 /*}}}*/
-/*FUNCTION SpcTransient::DeepEcho {{{*/
-void SpcTransient::DeepEcho(void){
+void SpcTransient::DeepEcho(void){/*{{{*/
 	this->Echo();
 }		
 /*}}}*/
-/*FUNCTION SpcTransient::Id {{{*/
-int    SpcTransient::Id(void){ return sid; }
+int    SpcTransient::Id(void){ return sid; }/*{{{*/
 /*}}}*/
-/*FUNCTION SpcTransient::ObjectEnum{{{*/
-int SpcTransient::ObjectEnum(void){
+int SpcTransient::ObjectEnum(void){/*{{{*/
 
 	return SpcTransientEnum;
@@ -84,6 +77,5 @@
 }
 /*}}}*/
-/*FUNCTION SpcTransient::copy {{{*/
-Object* SpcTransient::copy() {
+Object* SpcTransient::copy() {/*{{{*/
 	return new SpcTransient(sid,nodeid,dof,nsteps,times,values,analysis_type);
 }
@@ -91,6 +83,5 @@
 
 /*Constraint virtual functions definitions:*/
-/*FUNCTION SpcTransient::InAnalysis{{{*/
-bool SpcTransient::InAnalysis(int in_analysis_type){
+bool SpcTransient::InAnalysis(int in_analysis_type){/*{{{*/
 
 	if (in_analysis_type==this->analysis_type) return true;
@@ -98,6 +89,5 @@
 }
 /*}}}*/
-/*FUNCTION SpcTransient::ConstrainNode{{{*/
-void SpcTransient::ConstrainNode(Nodes* nodes,Parameters* parameters){
+void SpcTransient::ConstrainNode(Nodes* nodes,Parameters* parameters){/*{{{*/
 
 	Node       *node  = NULL;
@@ -149,17 +139,14 @@
 
 /*SpcTransient functions*/
-/*FUNCTION SpcTransient::GetDof {{{*/
-int SpcTransient::GetDof(){
+int SpcTransient::GetDof(){/*{{{*/
 	return dof;
 }
 /*}}}*/
-/*FUNCTION SpcTransient::GetNodeId {{{*/
-int   SpcTransient::GetNodeId(){
+int   SpcTransient::GetNodeId(){/*{{{*/
 
 	return nodeid;
 }
 /*}}}*/
-/*FUNCTION SpcTransient::GetValue {{{*/
-IssmDouble SpcTransient::GetValue(){
+IssmDouble SpcTransient::GetValue(){/*{{{*/
 	return values[0];
 }
Index: issm/trunk/src/c/classes/Contour.h
===================================================================
--- issm/trunk/src/c/classes/Contour.h	(revision 18081)
+++ issm/trunk/src/c/classes/Contour.h	(revision 18301)
@@ -24,6 +24,5 @@
 
 		/*Contour constructors, destructors :*/
-		/*FUNCTION Contour() {{{*/
-		Contour(){
+		Contour(){/*{{{*/
 			this->id     = 0;
 			this->nods   = 0;
@@ -33,6 +32,5 @@
 		}
 		/*}}}*/
-		/*FUNCTION Contour(int pid, int nods, doubletype* x, doubletype* y,bool closed) {{{*/
-		Contour(int pid,int pnods, doubletype* px, doubletype* py,bool pclosed){
+		Contour(int pid,int pnods, doubletype* px, doubletype* py,bool pclosed){/*{{{*/
 
 			this->id     = pid;
@@ -47,6 +45,5 @@
 		}
 		/*}}}*/
-		/*FUNCTION ~Contour() {{{*/
-		~Contour(){
+		~Contour(){/*{{{*/
 			xDelete<doubletype>(this->x);
 			xDelete<doubletype>(this->y);
@@ -55,6 +52,5 @@
 
 		/*Object virtual function resolutoin: */
-		/*FUNCTION Echo(){{{*/
-		void Echo(void){
+		void Echo(void){/*{{{*/
 			_printf_(" Contour: " << id << "\n");
 			_printf_("    nods: " << nods << "\n");
@@ -68,22 +64,21 @@
 		}
 		/*}}}*/
-		/*FUNCTION DeepEcho(){{{*/
-		void DeepEcho(void){
+		void DeepEcho(void){/*{{{*/
 			this->Echo();
 		}
 		/*}}}*/
-		/*FUNCTION Id(){{{*/
-		int Id(void){
+		int Id(void){/*{{{*/
 			return id;
 		}
 		/*}}}*/
-		/*FUNCTION ObjectEnum{{{*/
-		int ObjectEnum(void){
+		int ObjectEnum(void){/*{{{*/
 			return ContourEnum;
 		}
 		/*}}}*/
-		/*FUNCTION copy {{{*/
-		Object* copy() {
-			return new Contour(*this); 
+		Object* copy() {/*{{{*/
+
+			Contour* contour = new Contour(this->id,this->nods,this->x,this->y,this->closed);
+
+			return (Object*) contour;
 		}
 		/*}}}*/
Index: issm/trunk/src/c/classes/Contours.cpp
===================================================================
--- issm/trunk/src/c/classes/Contours.cpp	(revision 18081)
+++ issm/trunk/src/c/classes/Contours.cpp	(revision 18301)
@@ -19,12 +19,10 @@
 
 /*Object constructors and destructor*/
-/*FUNCTION Contours::Contours(){{{*/
-Contours::Contours(){
+Contours::Contours(){/*{{{*/
 	enum_type=ContoursEnum;
 	return;
 }
 /*}}}*/
-/*FUNCTION Contours::~Contours(){{{*/
-Contours::~Contours(){
+Contours::~Contours(){/*{{{*/
 	return;
 }
Index: issm/trunk/src/c/classes/DependentObject.cpp
===================================================================
--- issm/trunk/src/c/classes/DependentObject.cpp	(revision 18081)
+++ issm/trunk/src/c/classes/DependentObject.cpp	(revision 18301)
@@ -14,6 +14,5 @@
 
 /*DependentObject constructors and destructor*/
-/*FUNCTION DependentObject::DependentObject(){{{*/
-DependentObject::DependentObject(){
+DependentObject::DependentObject(){/*{{{*/
 	this->name=NULL;
 	this->type=0;
@@ -21,6 +20,5 @@
 }
 /*}}}*/
-/*FUNCTION DependentObject::DependentObject(int in_name, int in_type, int in_index){{{*/
-DependentObject::DependentObject(char* in_name, int in_type,int in_index){
+DependentObject::DependentObject(char* in_name, int in_type,int in_index){/*{{{*/
 
 	this->name=xNew<char>(strlen(in_name)+1); xMemCpy<char>(this->name,in_name,strlen(in_name)+1);
@@ -32,6 +30,5 @@
 }
 /*}}}*/
-/*FUNCTION DependentObject::~DependentObject() {{{*/
-DependentObject::~DependentObject(){ //destructor
+DependentObject::~DependentObject(){ //destructor/*{{{*/
 	xDelete<char>(this->name);
 }
@@ -39,6 +36,5 @@
 
 /*Object virtual functions definitions:*/
-/*FUNCTION DependentObject::Echo{{{*/
-void DependentObject::Echo(void){
+void DependentObject::Echo(void){/*{{{*/
 
 	_printf_("DependentObject:\n");
@@ -53,14 +49,11 @@
 }
 /*}}}*/
-/*FUNCTION DependentObject::DeepEcho{{{*/
-void DependentObject::DeepEcho(void){
+void DependentObject::DeepEcho(void){/*{{{*/
 	this->Echo();
 }
 /*}}}*/
-/*FUNCTION DependentObject::Id{{{*/
-int    DependentObject::Id(void){ return -1; }
+int    DependentObject::Id(void){ return -1; }/*{{{*/
 /*}}}*/
-/*FUNCTION DependentObject::ObjectEnum{{{*/
-int DependentObject::ObjectEnum(void){
+int DependentObject::ObjectEnum(void){/*{{{*/
 
 	return DependentObjectEnum;
@@ -68,12 +61,10 @@
 }
 /*}}}*/
-/*FUNCTION DependentObject::copy{{{*/
-Object* DependentObject::copy(void) { 
+Object* DependentObject::copy(void) { /*{{{*/
 	return new DependentObject(name,type,index);
 } /*}}}*/
 
 /*DependentObject methods: */
-/*FUNCTION DependentObject::NumDependents{{{*/
-int  DependentObject::NumDependents(void){
+int  DependentObject::NumDependents(void){/*{{{*/
 
 	/*Branch according to the type of variable: */
@@ -87,6 +78,5 @@
 }
 /*}}}*/
-/*FUNCTION DependentObject::Responsex{{{*/
-void  DependentObject::Responsex(IssmDouble* poutput_value,FemModel* femmodel){
+void  DependentObject::Responsex(IssmDouble* poutput_value,FemModel* femmodel){/*{{{*/
 
 	/*Is this some special type of response for which we need to go in the output definitions? :*/
Index: issm/trunk/src/c/classes/DofIndexing.cpp
===================================================================
--- issm/trunk/src/c/classes/DofIndexing.cpp	(revision 18081)
+++ issm/trunk/src/c/classes/DofIndexing.cpp	(revision 18301)
@@ -20,6 +20,5 @@
 
 /*DofIndexing constructors and destructor*/
-/*FUNCTION DofIndexing::DofIndexing(){{{*/
-DofIndexing::DofIndexing(){
+DofIndexing::DofIndexing(){/*{{{*/
 
 	this->gsize    = UNDEF;
@@ -38,6 +37,5 @@
 }
 /*}}}*/
-/*FUNCTION DofIndexing::DofIndexing(int gsize){{{*/
-DofIndexing::DofIndexing(int in_gsize){
+DofIndexing::DofIndexing(int in_gsize){/*{{{*/
 
 	this->Init(in_gsize,NULL);
@@ -45,6 +43,5 @@
 }
 /*}}}*/
-/*FUNCTION DofIndexing::DofIndexing(DofIndexing* in)  -> copy{{{*/
-DofIndexing::DofIndexing(DofIndexing* in){ //copy constructor
+DofIndexing::DofIndexing(DofIndexing* in){ //copy constructor/*{{{*/
 
 	this->gsize  = in->gsize;
@@ -58,5 +55,10 @@
 		this->s_set=xNew<bool>(this->gsize);
 		this->svalues=xNew<IssmDouble>(this->gsize);
-		if(in->doftype)this->doftype=xNew<int>(this->gsize); 
+		if(in->doftype){
+			this->doftype=xNew<int>(this->gsize); 
+		}
+		else{
+			this->doftype=NULL;
+		}
 		this->gdoflist=xNew<int>(this->gsize); 
 	}
@@ -68,6 +70,6 @@
 		this->gdoflist = NULL;
 	}
-	if(this->fsize>0 && this->fsize!=UNDEF)this->fdoflist=xNew<int>(this->fsize); else this->fdoflist=NULL;
-	if(this->ssize>0 && this->ssize!=UNDEF)this->sdoflist=xNew<int>(this->ssize); else this->sdoflist=NULL;
+	if(this->fsize>0)this->fdoflist=xNew<int>(this->fsize); else this->fdoflist=NULL;
+	if(this->ssize>0)this->sdoflist=xNew<int>(this->ssize); else this->sdoflist=NULL;
 
 	if(this->gsize>0){
@@ -78,24 +80,72 @@
 		memcpy(this->gdoflist,in->gdoflist,this->gsize*sizeof(int));
 	}
-	if(this->fsize>0 && this->fsize!=UNDEF)memcpy(this->fdoflist,in->fdoflist,this->fsize*sizeof(int));
-	if(this->ssize>0 && this->ssize!=UNDEF)memcpy(this->sdoflist,in->sdoflist,this->ssize*sizeof(int));
-
-}
-/*}}}*/
-/*FUNCTION DofIndexing::~DofIndexing() {{{*/
-DofIndexing::~DofIndexing(){ //destructor
-
-	xDelete<bool>(f_set); 
-	xDelete<bool>(s_set); 
-	xDelete<IssmDouble>(svalues);
-	xDelete<int>(doftype); 
-	xDelete<int>(gdoflist);
-	xDelete<int>(fdoflist);
-	xDelete<int>(sdoflist);
-
-}
-/*}}}*/
-/*FUNCTION DofIndexing::Init{{{*/
-void DofIndexing::Init(int in_gsize,int* in_doftype){
+	if(this->fsize>0)memcpy(this->fdoflist,in->fdoflist,this->fsize*sizeof(int));
+	if(this->ssize>0)memcpy(this->sdoflist,in->sdoflist,this->ssize*sizeof(int));
+
+}
+/*}}}*/
+DofIndexing::~DofIndexing(){ //destructor/*{{{*/
+
+	if(this->f_set) xDelete<bool>(f_set); 
+	if(this->s_set) xDelete<bool>(s_set); 
+	if(this->svalues) xDelete<IssmDouble>(svalues);
+	if(this->doftype) xDelete<int>(doftype); 
+	if(this->gdoflist) xDelete<int>(gdoflist);
+	if(this->fdoflist) xDelete<int>(fdoflist);
+	if(this->sdoflist) xDelete<int>(sdoflist);
+
+}
+/*}}}*/
+DofIndexing DofIndexing::operator=( const DofIndexing& in ){/*{{{*/
+
+	this->copy(in);
+
+	return this;
+}
+/*}}}*/
+void DofIndexing::copy(const DofIndexing& in ){/*{{{*/
+
+	this->gsize  = in.gsize;
+	this->fsize  = in.fsize;
+	this->ssize  = in.ssize;
+	this->clone  = in.clone;
+	this->active = in.active;
+
+	if(this->gsize>0){
+		this->f_set=xNew<bool>(this->gsize);
+		this->s_set=xNew<bool>(this->gsize);
+		this->svalues=xNew<IssmDouble>(this->gsize);
+		if(in.doftype){
+			this->doftype=xNew<int>(this->gsize);
+		}
+		else{
+			this->doftype=NULL;
+		}
+		this->gdoflist=xNew<int>(this->gsize);
+	}
+	else{
+		this->f_set    = NULL;
+		this->s_set    = NULL;
+		this->svalues  = NULL;
+		this->doftype  = NULL;
+		this->gdoflist = NULL;
+	}
+	if(this->fsize>0)this->fdoflist=xNew<int>(this->fsize); else this->fdoflist=NULL;
+	if(this->ssize>0)this->sdoflist=xNew<int>(this->ssize); else this->sdoflist=NULL;
+
+	if(this->gsize>0){
+		memcpy(this->f_set,in.f_set,this->gsize*sizeof(bool));
+		memcpy(this->s_set,in.s_set,this->gsize*sizeof(bool));
+		xMemCpy<IssmDouble>(this->svalues,in.svalues,this->gsize);
+		if(this->doftype)memcpy(this->doftype,in.doftype,this->gsize*sizeof(int));
+		memcpy(this->gdoflist,in.gdoflist,this->gsize*sizeof(int));
+	}
+	if(this->fsize>0)memcpy(this->fdoflist,in.fdoflist,this->fsize*sizeof(int));
+	if(this->ssize>0)memcpy(this->sdoflist,in.sdoflist,this->ssize*sizeof(int));
+
+	return;
+}
+/*}}}*/
+void DofIndexing::Init(int in_gsize,int* in_doftype){/*{{{*/
 
 	this->gsize = in_gsize;
@@ -106,11 +156,11 @@
 	/*memory allocation */
 	if(this->gsize>0){
-		this->f_set    = xNew<bool>(this->gsize);
-		this->s_set    = xNew<bool>(this->gsize);
-		this->svalues  = xNew<IssmDouble>(this->gsize);
-		this->gdoflist = xNew<int>(this->gsize);
-
-		if(in_doftype)
-		 this->doftype = xNew<int>(this->gsize);
+		this->f_set    = xNew<bool>((unsigned int)in_gsize);
+		this->s_set    = xNew<bool>((unsigned int)in_gsize);
+		this->svalues  = xNew<IssmDouble>((unsigned int)in_gsize);
+		this->gdoflist = xNew<int>((unsigned int)in_gsize);
+
+		if(in_doftype) this->doftype = xNew<int>((unsigned int)in_gsize);
+		else this->doftype = NULL;
 	}
 
@@ -122,11 +172,9 @@
 		this->gdoflist[i] = UNDEF;
 
-		if(this->doftype)
-		 this->doftype[i]=in_doftype[i];
-	}
-}
-/*}}}*/
-/*FUNCTION DofIndexing::InitSet{{{*/
-void DofIndexing::InitSet(int setenum){
+		if(this->doftype) this->doftype[i]=in_doftype[i];
+	}
+}
+/*}}}*/
+void DofIndexing::InitSet(int setenum){/*{{{*/
 
 	int i;
@@ -162,6 +210,5 @@
 
 /*Some of the Object functionality: */
-/*FUNCTION DofIndexing::Echo{{{*/
-void DofIndexing::Echo(void){
+void DofIndexing::Echo(void){/*{{{*/
 
 	_printf_("DofIndexing:\n");
@@ -173,6 +220,5 @@
 }
 /*}}}*/
-/*FUNCTION DofIndexing::DeepEcho{{{*/
-void DofIndexing::DeepEcho(void){
+void DofIndexing::DeepEcho(void){/*{{{*/
 
 	int i;
@@ -224,6 +270,5 @@
 }		
 /*}}}*/
-/*FUNCTION DofIndexing::Deactivate{{{*/
-void DofIndexing::Deactivate(void){
+void DofIndexing::Deactivate(void){/*{{{*/
 	this->active = false;
 
@@ -237,6 +282,5 @@
 }
 /*}}}*/
-/*FUNCTION DofIndexing::Activate{{{*/
-void DofIndexing::Activate(void){
+void DofIndexing::Activate(void){/*{{{*/
 	this->active = true;
 
Index: issm/trunk/src/c/classes/DofIndexing.h
===================================================================
--- issm/trunk/src/c/classes/DofIndexing.h	(revision 18081)
+++ issm/trunk/src/c/classes/DofIndexing.h	(revision 18301)
@@ -41,9 +41,10 @@
 		DofIndexing(DofIndexing* properties);
 		~DofIndexing();
+		DofIndexing operator=(const DofIndexing& in);
 		/*}}}*/
 		/*Object like functionality: {{{*/
 		void  Echo(void); 
 		void  DeepEcho(void); 
-		void  copy(DofIndexing* properties);
+		void  copy(const DofIndexing& in);
 		/*}}}*/
 		/*DofIndexing management: {{{*/
Index: issm/trunk/src/c/classes/Elements/Element.cpp
===================================================================
--- issm/trunk/src/c/classes/Elements/Element.cpp	(revision 18081)
+++ issm/trunk/src/c/classes/Elements/Element.cpp	(revision 18301)
@@ -26,6 +26,8 @@
 	this->inputs     = NULL;
 	this->parameters = NULL;
+	this->element_type_list=NULL;
 }/*}}}*/
 Element::~Element(){/*{{{*/
+	xDelete<int>(element_type_list);
 	delete inputs;
 }
@@ -39,4 +41,195 @@
 	this->inputs->AddInput(input_in);
 }/*}}}*/
+void       Element::ComputeNewDamage(){/*{{{*/
+
+	IssmDouble *xyz_list=NULL;
+	IssmDouble  eps_xx,eps_xy,eps_yy,eps_xz,eps_yz,eps_zz,eps_eff;
+	IssmDouble  epsmin=1.e-27;
+	IssmDouble  eps_0,eps_f,sigma_0,B,D,n;
+	int         dim,counter=0;
+	IssmDouble  k1,k2,threshold=1.e-12;
+
+	/* Retrieve parameters */
+	this->GetVerticesCoordinates(&xyz_list);
+	this->ComputeStrainRate();
+	parameters->FindParam(&dim,DomainDimensionEnum);
+	parameters->FindParam(&eps_f,DamageC1Enum);
+	parameters->FindParam(&sigma_0,DamageStressThresholdEnum);
+
+	/* Retrieve inputs */
+	Input* eps_xx_input=this->GetInput(StrainRatexxEnum); _assert_(eps_xx_input);
+	Input* eps_yy_input=this->GetInput(StrainRateyyEnum); _assert_(eps_yy_input);
+	Input* eps_xy_input=this->GetInput(StrainRatexyEnum); _assert_(eps_xy_input);
+	Input* eps_xz_input=NULL;
+	Input* eps_yz_input=NULL;
+	Input* eps_zz_input=NULL;
+	if(dim==3){
+		eps_xz_input=this->GetInput(StrainRatexzEnum); _assert_(eps_xz_input);
+		eps_yz_input=this->GetInput(StrainRateyzEnum); _assert_(eps_yz_input);
+		eps_zz_input=this->GetInput(StrainRatezzEnum); _assert_(eps_zz_input);
+	}
+
+	/* Fetch number of nodes and allocate output*/
+   int numnodes = this->GetNumberOfNodes();
+   IssmDouble* newD = xNew<IssmDouble>(numnodes);
+
+	/* Retrieve domain-dependent inputs */
+	Input* n_input=this->GetInput(MaterialsRheologyNEnum); _assert_(n_input);
+   Input* damage_input = NULL;
+   Input* B_input = NULL;
+	int domaintype;
+   parameters->FindParam(&domaintype,DomainTypeEnum);
+	if(domaintype==Domain2DhorizontalEnum){
+      damage_input = this->GetInput(DamageDbarEnum);  _assert_(damage_input);
+      B_input=this->GetInput(MaterialsRheologyBbarEnum); _assert_(B_input);
+   }
+   else{
+      damage_input = this->GetInput(DamageDEnum);   _assert_(damage_input);
+      B_input=this->GetInput(MaterialsRheologyBEnum); _assert_(B_input);
+   }
+	
+	/* Start looping on the number of nodes: */
+	Gauss* gauss=this->NewGauss();
+	for (int i=0;i<numnodes;i++){
+		gauss->GaussNode(this->GetElementType(),i);
+
+		eps_xx_input->GetInputValue(&eps_xx,gauss);
+		eps_yy_input->GetInputValue(&eps_yy,gauss);
+		eps_xy_input->GetInputValue(&eps_xy,gauss);
+		if(dim==3){
+			eps_xz_input->GetInputValue(&eps_xz,gauss);
+			eps_yz_input->GetInputValue(&eps_yz,gauss);
+			eps_zz_input->GetInputValue(&eps_zz,gauss);
+		}
+		else{eps_xz=0; eps_yz=0; eps_zz=0;}
+
+		/* eps_eff^2 = exx^2 + eyy^2 + exy^2 + exz^2 + eyz^2 + exx*eyy */
+		eps_eff=sqrt(eps_xx*eps_xx+eps_yy*eps_yy+eps_xy*eps_xy+eps_xz*eps_xz+eps_yz*eps_yz+eps_xx*eps_yy+epsmin*epsmin);
+
+		B_input->GetInputValue(&B,gauss);
+      n_input->GetInputValue(&n,gauss);
+      damage_input->GetInputValue(&D,gauss);
+
+		/* Compute threshold strain rate from threshold stress */
+		eps_0=pow(sigma_0/B,n); 
+		_assert_(eps_f>eps_0);
+
+		/* Compute kappa (k) from pre-existing level of damage, using Newton-Raphson */
+		/* provide a reasonable initial guess */
+		if(D==0){
+			k1=eps_0;
+		}
+		else{
+			k1=exp(n*eps_0/(eps_f-eps_0)-n*log(1.-D)+log(eps_0)); /* initial guess */
+		}
+	
+		counter=0;
+		while(true){
+      	/*Newton step k2=k1-f(k1)/f'(k1) */
+			k2=k1-(k1+(eps_f-eps_0)/n*log(k1)-eps_0+(eps_f-eps_0)*(log(1.-D)-1./n*log(eps_0)))/(1.+(eps_f-eps_0)/n/k1);
+
+      	if( fabs(k2-k1)/(fabs(k2))<threshold ){
+         	break;
+      	}
+      	else{
+				k1=k2;
+      	   counter++;
+      	}
+
+      	if(counter>50) break;
+   	}
+
+		if(eps_eff>k2){
+			newD[i]=1.-pow(eps_0/eps_eff,1./n)*exp(-(eps_eff-eps_0)/(eps_f-eps_0));
+		}
+		else newD[i]=D;
+	}
+
+	/* Add new damage input to DamageEnum and NewDamageEnum */
+	this->AddInput(NewDamageEnum,newD,this->GetElementType());
+	if(domaintype==Domain2DhorizontalEnum){
+		this->AddInput(DamageDbarEnum,newD,this->GetElementType());
+	}
+	else{
+		this->AddInput(DamageDEnum,newD,this->GetElementType());
+	}
+
+	/*Clean up and return*/
+	xDelete<IssmDouble>(xyz_list);
+	xDelete<IssmDouble>(newD);
+	delete gauss;
+
+}/*}}}*/
+void       Element::ComputeStrainRate(){/*{{{*/
+
+	int         dim;
+	IssmDouble *xyz_list = NULL;
+	IssmDouble  epsilon[6];
+
+	/*Retrieve all inputs we will be needing: */
+	this->GetVerticesCoordinates(&xyz_list);
+	parameters->FindParam(&dim,DomainDimensionEnum);
+	Input* vx_input=this->GetInput(VxEnum); _assert_(vx_input);
+	Input* vy_input=this->GetInput(VyEnum); _assert_(vy_input);
+	Input* vz_input=NULL;
+	if(dim==3){vz_input=this->GetInput(VzEnum); _assert_(vz_input);}
+
+	/*Allocate arrays*/
+	int numvertices = this->GetNumberOfVertices();
+	IssmDouble* eps_xx = xNew<IssmDouble>(numvertices);
+	IssmDouble* eps_yy = xNew<IssmDouble>(numvertices);
+	IssmDouble* eps_zz = xNew<IssmDouble>(numvertices);
+	IssmDouble* eps_xy = xNew<IssmDouble>(numvertices);
+	IssmDouble* eps_xz = xNew<IssmDouble>(numvertices);
+	IssmDouble* eps_yz = xNew<IssmDouble>(numvertices);
+
+	/* Start looping on the number of vertices: */
+	Gauss* gauss=this->NewGauss();
+	for (int iv=0;iv<numvertices;iv++){
+		gauss->GaussVertex(iv);
+
+		/*Compute strain rate viscosity and pressure: */
+		if(dim==2)
+		 this->StrainRateSSA(&epsilon[0],xyz_list,gauss,vx_input,vy_input);
+		else
+		 this->StrainRateFS(&epsilon[0],xyz_list,gauss,vx_input,vy_input,vz_input);
+
+		if(dim==2){
+			 /* epsilon=[exx,eyy,exy];*/
+			eps_xx[iv]=epsilon[0]; 
+			eps_yy[iv]=epsilon[1];
+			eps_xy[iv]=epsilon[2];
+		}
+		else{
+			/*epsilon=[exx eyy ezz exy exz eyz]*/
+			eps_xx[iv]=epsilon[0]; 
+			eps_yy[iv]=epsilon[1];
+			eps_zz[iv]=epsilon[2];
+			eps_xy[iv]=epsilon[3]; 
+			eps_xz[iv]=epsilon[4];
+			eps_yz[iv]=epsilon[5];
+		}
+	}
+
+	/*Add Stress tensor components into inputs*/
+	this->AddInput(StrainRatexxEnum,eps_xx,P1Enum);
+	this->AddInput(StrainRatexyEnum,eps_xy,P1Enum);
+	this->AddInput(StrainRatexzEnum,eps_xz,P1Enum);
+	this->AddInput(StrainRateyyEnum,eps_yy,P1Enum);
+	this->AddInput(StrainRateyzEnum,eps_yz,P1Enum);
+	this->AddInput(StrainRatezzEnum,eps_zz,P1Enum);
+
+	/*Clean up and return*/
+	delete gauss;
+	xDelete<IssmDouble>(xyz_list);
+	xDelete<IssmDouble>(eps_xx);
+	xDelete<IssmDouble>(eps_yy);
+	xDelete<IssmDouble>(eps_zz);
+	xDelete<IssmDouble>(eps_xy);
+	xDelete<IssmDouble>(eps_xz);
+	xDelete<IssmDouble>(eps_yz);
+
+}
+/*}}}*/
 void       Element::CoordinateSystemTransform(IssmDouble** ptransform,Node** nodes_list,int numnodes,int* cs_array){/*{{{*/
 
@@ -162,5 +355,8 @@
 	if(nodes){
 		int numnodes = this->GetNumberOfNodes();
-		for(int i=0;i<numnodes;i++) nodes[i]->Echo();
+		for(int i=0;i<numnodes;i++) {
+			_printf_("nodes[" << i << "] = " << nodes[i]);	
+			nodes[i]->Echo();
+		}
 	}
 	else _printf_("nodes = NULL\n");
@@ -185,4 +381,5 @@
 
 	/*Intermediaries*/
+	int        dim;
 	IssmDouble Jdet;
 	IssmDouble divergence=0.;
@@ -191,10 +388,14 @@
 
 	/*Get inputs and parameters*/
-	Input* vx_input        = this->GetInput(VxEnum); _assert_(vx_input);
-	Input* vy_input        = this->GetInput(VyEnum); _assert_(vy_input);
-	Input* vz_input        = this->GetInput(VzEnum); _assert_(vz_input);
+	this->FindParam(&dim,DomainDimensionEnum);
+	Input* vx_input = this->GetInput(VxEnum); _assert_(vx_input);
+	Input* vy_input = this->GetInput(VyEnum); _assert_(vy_input);
+	Input* vz_input = NULL;
+	if(dim==3){
+		vz_input = this->GetInput(VzEnum); _assert_(vz_input);
+	}
 	this->GetVerticesCoordinates(&xyz_list);
 
-	Gauss* gauss=this->NewGaussBase(5);
+	Gauss* gauss=this->NewGauss(5);
 	for(int ig=gauss->begin();ig<gauss->end();ig++){
 		gauss->GaussPoint(ig);
@@ -204,7 +405,12 @@
 		vx_input->GetInputDerivativeValue(&dvx[0],xyz_list,gauss);
 		vy_input->GetInputDerivativeValue(&dvy[0],xyz_list,gauss);
-		vz_input->GetInputDerivativeValue(&dvz[0],xyz_list,gauss);
-
-		divergence += (dvx[0]+dvy[1]+dvz[2])*gauss->weight*Jdet;
+		if(dim==2){
+			divergence += (dvx[0]+dvy[1])*gauss->weight*Jdet;
+		}
+		else{
+			vz_input->GetInputDerivativeValue(&dvz[0],xyz_list,gauss);
+			divergence += (dvx[0]+dvy[1]+dvz[2])*gauss->weight*Jdet;
+		}
+
 	}
 
@@ -213,4 +419,58 @@
 	return divergence;
 }/*}}}*/
+void       Element::dViscositydBSSA(IssmDouble* pdmudB,int dim,IssmDouble* xyz_list,Gauss* gauss,Input* vx_input,Input* vy_input){/*{{{*/
+
+	/*Intermediaries*/
+	IssmDouble dmudB;
+	IssmDouble epsilon2d[3];/* epsilon=[exx,eyy,exy];    */
+	IssmDouble epsilon1d;   /* epsilon=[exx];    */
+	IssmDouble eps_eff;
+
+	 if(dim==2){
+		 /* eps_eff^2 = exx^2 + eyy^2 + exy^2 + exx*eyy*/
+		 this->StrainRateSSA(&epsilon2d[0],xyz_list,gauss,vx_input,vy_input);
+		 eps_eff = sqrt(epsilon2d[0]*epsilon2d[0] + epsilon2d[1]*epsilon2d[1] + epsilon2d[2]*epsilon2d[2] + epsilon2d[0]*epsilon2d[1]);
+	 }
+	 else{
+		 /* eps_eff^2 = 1/2 exx^2*/
+		 this->StrainRateSSA1d(&epsilon1d,xyz_list,gauss,vx_input);
+		 eps_eff = sqrt(epsilon1d*epsilon1d/2.);
+	 }
+
+	/*Get viscosity*/
+	material->GetViscosity_B(&dmudB,eps_eff);
+
+	/*Assign output pointer*/
+	*pdmudB=dmudB;
+
+}
+/*}}}*/
+void       Element::dViscositydDSSA(IssmDouble* pdmudB,int dim,IssmDouble* xyz_list,Gauss* gauss,Input* vx_input,Input* vy_input){/*{{{*/
+
+	/*Intermediaries*/
+	IssmDouble dmudB;
+	IssmDouble epsilon2d[3];/* epsilon=[exx,eyy,exy];    */
+	IssmDouble epsilon1d;   /* epsilon=[exx];    */
+	IssmDouble eps_eff;
+
+	if(dim==2){
+		/* eps_eff^2 = exx^2 + eyy^2 + exy^2 + exx*eyy*/
+		this->StrainRateSSA(&epsilon2d[0],xyz_list,gauss,vx_input,vy_input);
+		eps_eff = sqrt(epsilon2d[0]*epsilon2d[0] + epsilon2d[1]*epsilon2d[1] + epsilon2d[2]*epsilon2d[2] + epsilon2d[0]*epsilon2d[1]);
+	}
+	else{
+		/* eps_eff^2 = 1/2 exx^2*/
+		this->StrainRateSSA1d(&epsilon1d,xyz_list,gauss,vx_input);
+		eps_eff = sqrt(epsilon1d*epsilon1d/2.);
+	}
+
+	/*Get viscosity*/
+	material->GetViscosity_D(&dmudB,eps_eff);
+
+	/*Assign output pointer*/
+	*pdmudB=dmudB;
+
+}
+/*}}}*/
 void       Element::ThermalToEnthalpy(IssmDouble* penthalpy,IssmDouble temperature,IssmDouble waterfraction,IssmDouble pressure){/*{{{*/
 	matpar->ThermalToEnthalpy(penthalpy,temperature,waterfraction,pressure);
@@ -603,4 +863,20 @@
 	return z;
 }/*}}}*/
+void       Element::GradientIndexing(int* indexing,int control_index){/*{{{*/
+
+	/*Get number of controls*/
+	int num_controls;
+	parameters->FindParam(&num_controls,InversionNumControlParametersEnum);
+
+	/*Get number of vertices*/
+	int numvertices = this->GetNumberOfVertices();
+
+	/*get gradient indices*/
+	for(int i=0;i<numvertices;i++){
+		indexing[i]=num_controls*this->vertices[i]->Pid() + control_index;
+	}
+
+}
+/*}}}*/
 bool       Element::HasNodeOnBase(){/*{{{*/
 	return (this->inputs->Max(MeshVertexonbaseEnum)>0.);
@@ -749,8 +1025,12 @@
 				name==BaseEnum ||
 				name==BedEnum ||
+				name==BalancethicknessThickeningRateEnum ||
+				name==BalancethicknessApparentMassbalanceEnum ||
+				name==SigmaNNEnum ||
 				name==SurfaceSlopeXEnum ||
 				name==SurfaceSlopeYEnum ||
 				name==SurfaceforcingsMassBalanceEnum ||
-				name==BasalforcingsMeltingRateEnum ||
+				name==BasalforcingsGroundediceMeltingRateEnum ||
+				name==BasalforcingsFloatingiceMeltingRateEnum ||
 				name==BasalforcingsGeothermalfluxEnum ||
 				name==SurfaceAreaEnum||
@@ -783,19 +1063,4 @@
 				name==OldGradientEnum  ||
 				name==ConvergedEnum || 
-				name==QmuVxEnum ||
-				name==QmuVyEnum ||
-				name==QmuVzEnum ||
-				name==QmuVxMeshEnum ||
-				name==QmuVyMeshEnum ||
-				name==QmuVzMeshEnum ||
-				name==QmuPressureEnum ||
-				name==QmuBaseEnum ||
-				name==QmuThicknessEnum ||
-				name==QmuSurfaceEnum ||
-				name==QmuTemperatureEnum ||
-				name==QmuMeltingEnum ||
-				name==QmuMaskGroundediceLevelsetEnum ||
-				name==QmuMaskIceLevelsetEnum ||
-				name==QmuMaterialsRheologyBEnum ||
 				name==MaterialsRheologyBEnum ||
 				name==MaterialsRheologyBbarEnum ||
@@ -819,4 +1084,25 @@
 }
 /*}}}*/
+void       Element::LinearFloatingiceMeltingRate(){/*{{{*/
+
+	int numvertices      = this->GetNumberOfVertices();
+	IssmDouble  deepwaterel,upperwaterel,deepwatermelt;
+	IssmDouble* base     = xNew<IssmDouble>(numvertices);
+	IssmDouble* values   = xNew<IssmDouble>(numvertices);
+
+	parameters->FindParam(&deepwaterel,BasalforcingsDeepwaterElevationEnum);
+	parameters->FindParam(&upperwaterel,BasalforcingsUpperwaterElevationEnum);
+	parameters->FindParam(&deepwatermelt,BasalforcingsDeepwaterMeltingRateEnum);
+
+	this->GetInputListOnVertices(base,BaseEnum);
+	for(int i=0;i<numvertices;i++){
+		if(base[i]>upperwaterel)      values[i]=0;
+		else if (base[i]<deepwaterel) values[i]=deepwatermelt;
+		else values[i]=deepwatermelt*(base[i]-upperwaterel)/(deepwaterel-upperwaterel);
+	}
+
+	this->AddInput(BasalforcingsFloatingiceMeltingRateEnum,values,P1Enum);
+
+}/*}}}*/
 ElementVector* Element::NewElementVector(int approximation_enum){/*{{{*/
 	return new ElementVector(nodes,this->GetNumberOfNodes(),this->parameters,approximation_enum);
@@ -876,4 +1162,8 @@
 				input=this->inputs->GetInput(output_enum);
 				break;
+			case NewDamageEnum:
+				this->ComputeNewDamage();
+				input=this->inputs->GetInput(output_enum);
+				break;
 			default:
 				_error_("input "<<EnumToStringx(output_enum)<<" not found in element");
@@ -904,5 +1194,7 @@
 					break;
 				default:
-					_error_("Input of type "<<EnumToStringx(input->GetResultInterpolation())<<" not supported");
+					Gauss* gauss = this->NewGauss();
+					input->GetInputValue(&value,gauss);
+					delete gauss;
 			}
 			vector->SetValue(this->Sid(),value,INS_VAL);
